# NVUI
![first](assets/display/1.png)

## Featuring
<ul>
<li> Custom Titlebar (toggleable, see <code>:h nvui-titlebar</code>)</li>
</ul>
<ul>
<li> External Command Line (<code>nvui --ext_cmdline</code>)</li>
<li> Configurable positions, sizes, colors, border width, border color, etc.</li>
<li> For more information see <code>:h nvui-cmdline</code></li>
</ul>

![ext_cmdline](assets/display/2.png)
<ul>
<li> External Popup Menu (<code>nvui --ext_popupmenu</code>)</li>
<li> Configurable colors, background colors, icon sizes, alignment, border width, border color, etc.</li>
<li> For more information see <code>:h nvui-popup</code></li>
</ul>

![ext_popupmenu](assets/display/3.png)
<ul>
<li> Cross-platform Qt, DirectWrite on Windows</li>
</ul>
<ul>
<li> Font Fallback (see guifont in the bottom left)</li>
<li> Configurable through "set guifont"</li>
</ul>

![fallback](assets/display/4.png)


<ul>
<li> External Multigrid Support (<code>:h nvui-multigrid</code>) </li>
<li> <code>nvui --ext_multigrid</code></li>
<li> Smooth Scrolling </li>

[Smooth scrolling Demo](https://user-images.githubusercontent.com/64917719/131388187-7807833e-0fce-4db2-a25e-1e6ac7d48aed.mp4)

<li> Animated Windows</li>

[Animated windows Demo](https://user-images.githubusercontent.com/64917719/131388158-84783f63-0e43-45e7-8b9d-7e0d85649cb3.mp4)

<li> Animated Cursor (no VFX... yet) </li>
<li> Customizable cursor height (see <code>:h NvuiCaretExtendTop</code>
and <code>:h NvuiCaretExtendBottom</code>)
  <ul>
    <li> Ex. <code>:NvuiCaretExtendTop 200</code>, <code>:NvuiCaretExtendBottom 100</code> (see below)</li>
  </ul>
</ul>

[Cursor extending Demo](https://user-images.githubusercontent.com/64917719/131388133-379a32ae-1b36-4dc2-aee9-4303c20dc764.mp4)

## Documentation
<code>:h nvui</code> (vim/doc/nvui.txt)

## Build Instructions
See [the wiki](https://github.com/rohit-px2/nvui/wiki#build-instructions)

## Configuration (Command Line Arguments / Vim Configuration)
See [the wiki](https://github.com/rohit-px2/nvui/wiki#configuration-options)
and `:h nvui` for Vim command documentation.
